unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, MovedPanel, RXCombos, Animate,
  GIFCtrl;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    MovedPanel1: TMovedPanel;
    Label1: TLabel;
    LabelSpeed: TLabel;
    BitBtnStartStop: TBitBtn;
    SpeedButtonMinus: TSpeedButton;
    SpeedButtonPlus: TSpeedButton;
    Label2: TLabel;
    ComboBox1: TComboBox;
    MovedPanel2: TMovedPanel;
    Panel2: TPanel;
    Label3: TLabel;
    CheckBox1: TCheckBox;
    ColorComboBox1: TColorComboBox;
    RxGIFAnimator1: TRxGIFAnimator;
    Button1: TButton;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Image1: TImage;
    CheckBox5: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtnStartStopClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButtonMinusClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ColorComboBox1Change(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
  private
    pMovedPanel:TMovedPanel;
    procedure ChangeStartStopCaption;
    procedure ChangeSpeedInfo;
    procedure ChangeTypeInfo;
  public
  end;

var
  Form1: TForm1;

//======================================================
implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin //Create
  Constraints.MinHeight:=Height;
  Constraints.MinWidth :=Width;
  PageControl1Change(nil);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin //Close
  Close;
end;

procedure TForm1.BitBtnStartStopClick(Sender: TObject);
begin  //Start/Stop
  pMovedPanel.Animate:=not pMovedPanel.Animate;
  ChangeStartStopCaption;
end;

procedure TForm1.ChangeStartStopCaption;
begin
  if pMovedPanel.Animate then BitBtnStartStop.Caption:='Stop !'
  else BitBtnStartStop.Caption:='Start !';
end;

procedure TForm1.ChangeSpeedInfo;
begin
  LabelSpeed.Caption:=Format('%d',[pMovedPanel.TimerInterval]);
end;

procedure TForm1.ChangeTypeInfo;
begin
  ComboBox1.ItemIndex:=integer(pMovedPanel.AnimateType);
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  MovedPanel1.Animate:=false;
  MovedPanel2.Animate:=false;
  if PageControl1.ActivePage=TabSheet1 then
  pMovedPanel:=MovedPanel1 else pMovedPanel:=MovedPanel2;
  ChangeStartStopCaption;
  ChangeSpeedInfo;
  ChangeTypeInfo;
end;

procedure TForm1.SpeedButtonMinusClick(Sender: TObject);
var i,j:integer;
begin //Speed
  i:=pMovedPanel.TimerInterval;
  if i>50 then j:=10 else j:=5;
  if Sender=SpeedButtonMinus then Dec(i,j);
  if Sender=SpeedButtonPlus  then Inc(i,j);
  if i<5 then i:=5;
  if i>500 then i:=500;
  pMovedPanel.TimerInterval:=i;
  ChangeSpeedInfo;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin //Type
  with pMovedPanel do //move to center
  SetBounds(
    (Parent.Width-Width)div 2,
    (Parent.Height-Height)div 2,
    Width, Height);
  pMovedPanel.AnimateType:=TMovedPanelAnimateType(ComboBox1.ItemIndex);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
var i:integer;
  bv:TPanelBevel;
begin //Border
  if CheckBox1.Checked then
  begin
    i:=5;
    bv:=bvRaised;
  end
  else
  begin
    i:=0;
    bv:=bvNone;
  end;
  with MovedPanel1 do
  begin
    BorderWidth:=i;
    BevelOuter:=bv;
    Refresh;
  end;
end;

procedure TForm1.ColorComboBox1Change(Sender: TObject);
begin //Border Color
  MovedPanel1.BorderColor:=ColorComboBox1.ColorValue;
  MovedPanel1.Refresh;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  RxGIFAnimator1.Animate:=CheckBox2.Checked;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  RxGIFAnimator1.Visible:=CheckBox3.Checked;
  MovedPanel2.Refresh;
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
begin
  Image1.Visible:=CheckBox5.Checked;
  MovedPanel2.Refresh;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
var b:boolean;
begin
  b:=CheckBox4.Checked;
  Button1.Visible:=b;
  CheckBox2.Visible:=b;
  CheckBox3.Visible:=b;
  CheckBox5.Visible:=b;
  MovedPanel2.Refresh;
end;


end.
